use crate::types::Json;
use serde_json::json;

pub fn get_default_permission() -> Json {
  // Copied from apitable/packages/core/src/modules/shared/store/constants.ts
  json!({
    "allowEditConfigurable": false,
    "allowSaveConfigurable": false,
    "childCreatable": false,
    "copyable": false,
    "descriptionEditable": false,
    "editable": false,
    "iconEditable": false,
    "importable": false,
    "manageable": false,
    "movable": false,
    "nodeAssignable": false,
    "readable": false,
    "removable": false,
    "renamable": false,
    "sharable": false,
    "templateCreatable": false,
    "exportable": false,
    "viewCreatable": false,
    "viewRenamable": false,
    "viewRemovable": false,
    "viewMovable": false,
    "viewExportable": false,
    "viewFilterable": false,
    "columnSortable": false,
    "columnHideable": false,
    "fieldSortable": false,
    "fieldGroupable": false,
    "rowHighEditable": false,
    "columnWidthEditable": false,
    "columnCountEditable": false,
    "fieldCreatable": false,
    "fieldRenamable": false,
    "fieldPropertyEditable": false,
    "fieldRemovable": false,
    "rowCreatable": false,
    "rowRemovable": false,
    "cellEditable": false,
    "rowSortable": false,
    "fieldPermissionManageable": false,
    "viewLayoutEditable": false,
    "viewStyleEditable": false,
    "viewKeyFieldEditable": false,
    "viewColorOptionEditable": false,
    "viewManualSaveManageable": false,
    "viewOptionSaveEditable": false
  })
}

#[allow(unused)]
pub fn get_default_manager_permission() -> Json {
  // Copied from apitable/packages/core/src/modules/shared/store/constants.ts
  json!({
    "allowEditConfigurable": true,
    "allowSaveConfigurable": true,
    "childCreatable": true,
    "copyable": true,
    "descriptionEditable": true,
    "editable": true,
    "iconEditable": true,
    "exportable": true,
    "importable": true,
    "manageable": true,
    "movable": true,
    "nodeAssignable": true,
    "readable": true,
    "removable": true,
    "renamable": true,
    "sharable": true,
    "templateCreatable": true,
    "viewCreatable": true,
    "viewRenamable": true,
    "viewRemovable": true,
    "viewMovable": true,
    "viewExportable": true,
    "viewFilterable": true,
    "columnSortable": true,
    "columnHideable": true,
    "rowSortable": true,
    "fieldSortable": true,
    "fieldGroupable": true,
    "rowHighEditable": true,
    "columnWidthEditable": true,
    "columnCountEditable": true,
    "fieldCreatable": true,
    "fieldRenamable": true,
    "fieldPropertyEditable": true,
    "fieldRemovable": true,
    "rowCreatable": true,
    "rowRemovable": true,
    "cellEditable": true,
    "fieldPermissionManageable": true,
    "viewLayoutEditable": true,
    "viewStyleEditable": true,
    "viewKeyFieldEditable": true,
    "viewColorOptionEditable": true,
    "viewManualSaveManageable": true,
    "viewOptionSaveEditable": true
  })
}

pub fn get_default_editor_permission() -> Json {
  // Copied from apitable/packages/core/src/modules/shared/store/constants.ts
  json!({
    "allowEditConfigurable": false,
    "allowSaveConfigurable": false,
    "childCreatable": false,
    "copyable": false,
    "descriptionEditable": false,
    "editable": true,
    "iconEditable": false,
    "exportable": false,
    "importable": false,
    "manageable": false,
    "movable": false,
    "nodeAssignable": false,
    "readable": true,
    "removable": false,
    "renamable": false,
    "sharable": true,
    "templateCreatable": false,
    "viewCreatable": true,
    "viewRenamable": true,
    "viewRemovable": true,
    "viewMovable": true,
    "viewExportable": false,
    "viewFilterable": true,
    "columnSortable": true,
    "columnHideable": true,
    "rowSortable": true,
    "fieldSortable": true,
    "fieldGroupable": true,
    "rowHighEditable": true,
    "columnWidthEditable": true,
    "columnCountEditable": true,
    "fieldCreatable": false,
    "fieldRenamable": false,
    "fieldPropertyEditable": false,
    "fieldRemovable": false,
    "rowCreatable": true,
    "rowRemovable": true,
    "cellEditable": true,
    "fieldPermissionManageable": false,
    "viewLayoutEditable": true,
    "viewStyleEditable": true,
    "viewKeyFieldEditable": true,
    "viewColorOptionEditable": true,
    "viewManualSaveManageable": false,
    "viewOptionSaveEditable": true
  })
}

pub fn get_default_read_only_permission() -> Json {
  // Copied from apitable/packages/core/src/modules/shared/store/constants.ts
  json!({
    "allowEditConfigurable": false,
    "allowSaveConfigurable": false,
    "childCreatable": false,
    "copyable": false,
    "descriptionEditable": false,
    "exportable": false,
    "editable": false,
    "iconEditable": false,
    "importable": false,
    "manageable": false,
    "movable": false,
    "nodeAssignable": false,
    "readable": true,
    "removable": false,
    "renamable": false,
    "sharable": false,
    "templateCreatable": false,
    "viewCreatable": false,
    "viewRenamable": false,
    "viewRemovable": false,
    "viewMovable": false,
    "viewExportable": false,
    "viewFilterable": false,
    "columnSortable": false,
    "columnHideable": false,
    "fieldSortable": false,
    "fieldGroupable": false,
    "rowHighEditable": false,
    "columnWidthEditable": false,
    "columnCountEditable": false,
    "fieldCreatable": false,
    "fieldRenamable": false,
    "fieldPropertyEditable": false,
    "fieldRemovable": false,
    "rowCreatable": false,
    "rowRemovable": false,
    "cellEditable": false,
    "rowSortable": false,
    "fieldPermissionManageable": false,
    "viewLayoutEditable": false,
    "viewStyleEditable": false,
    "viewKeyFieldEditable": false,
    "viewColorOptionEditable": false,
    "viewManualSaveManageable": false,
    "viewOptionSaveEditable": false
  })
}
